Deployments
Generated on 18 Mar 2026
https://api.paperspace.com/v1
Endpoints
GET List deployments
/deployments
Authorizations:
BearerAuth
An API key or access token
Fetches a list of deployments for a logged in user.
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descRequest: /deployments
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
basicAuthKey
optional Nullable
The endpoint security key for the deployment
dtCreated
required
The date the deployment was created
endpoint
required
The unique endpoint for the deployment
id
required
The ID of the deployment
latestSpec
optional Nullable
The latest deployment configuration. If invalid, null is returned.
Show child properties
data
optional Nullable
The data for the deployment spec
Option 2
apiVersion
required
basicAuthKey
optional
command
optional
containerRegistry
optional
enabled
optional
env
optional
healthChecks
optional
healthchecks
optional
image
required
integrations
optional
name
required
region
optional
resources
required
deploymentId
required
The ID of the deployment the spec belongs to
dtHealthy
optional Nullable
The date the deployment was marked "healthy"
error
optional Nullable
The fatal configuration error. Only present if the cluster was unable to apply the entire deployment configuration. This is not the same as an instance error.
externalApplied
optional Nullable
The date the deployment configuration was applied to the cluster
id
required
The ID of the deployment spec
metadata
optional Nullable
Metadata about the source of the configuration
Show child properties
gitHeaders
optional
userId
required
The ID of the user the deployment belongs to
latestSpecHash
optional Nullable
The last version hash for the deployment
name
required
The name of the deployment
projectId
required
The ID of the project the deployment belongs to
teamId
required
The ID of the team the deployment belongs to
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"basicAuthKey": "string",
"dtCreated": "2019-08-24T14:15:22Z",
"endpoint": "string",
"id": "string",
"latestSpecHash": "string",
"name": "string",
"projectId": "string",
"teamId": "string"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}POST Upsert a deployment
/deployments
Authorizations:
BearerAuth
An API key or access token
Submit a new deployment configuration. If a deployment does not exist, one is created. Otherwise, a deployment is updated with new configuration.
Request Body: application/json
config
required
The deployment configuration
Option 2
apiVersion
required
basicAuthKey
optional
command
optional
containerRegistry
optional
enabled
optional
env
optional
Show child properties
name
required
value
required
healthChecks
optional
Show child properties
liveness
optional
Option 1
failureThreshold
optional
headers
optional
host
optional
initialDelaySeconds
optional
path
required
periodSeconds
optional
port
optional
timeoutSeconds
optional
Option 2
exec
required
failureThreshold
optional
initialDelaySeconds
optional
periodSeconds
optional
timeoutSeconds
optional
readiness
optional
Option 1
failureThreshold
optional
headers
optional
host
optional
initialDelaySeconds
optional
path
required
periodSeconds
optional
port
optional
timeoutSeconds
optional
Option 2
exec
required
failureThreshold
optional
initialDelaySeconds
optional
periodSeconds
optional
timeoutSeconds
optional
startup
optional
Option 1
failureThreshold
optional
headers
optional
host
optional
initialDelaySeconds
optional
path
required
periodSeconds
optional
port
optional
timeoutSeconds
optional
Option 2
exec
required
failureThreshold
optional
initialDelaySeconds
optional
periodSeconds
optional
timeoutSeconds
optional
healthchecks
optional
Show child properties
liveness
optional
Option 1
failureThreshold
optional
headers
optional
host
optional
initialDelaySeconds
optional
path
required
periodSeconds
optional
port
optional
timeoutSeconds
optional
Option 2
exec
required
failureThreshold
optional
initialDelaySeconds
optional
periodSeconds
optional
timeoutSeconds
optional
readiness
optional
Option 1
failureThreshold
optional
headers
optional
host
optional
initialDelaySeconds
optional
path
required
periodSeconds
optional
port
optional
timeoutSeconds
optional
Option 2
exec
required
failureThreshold
optional
initialDelaySeconds
optional
periodSeconds
optional
timeoutSeconds
optional
startup
optional
Option 1
failureThreshold
optional
headers
optional
host
optional
initialDelaySeconds
optional
path
required
periodSeconds
optional
port
optional
timeoutSeconds
optional
Option 2
exec
required
failureThreshold
optional
initialDelaySeconds
optional
periodSeconds
optional
timeoutSeconds
optional
image
required
integrations
optional
name
required
region
optional
resources
required
Show child properties
autoscaling
optional
Show child properties
enabled
optional
maxReplicas
required
metrics
required
machineType
required
ports
required
replicas
optional
deploymentId
optional Nullable
The ID of the deployment to update.
projectId
required
The project ID to deploy resources under.
Request: /deployments
{
"config": {
"apiVersion": "v0alpha0",
"command": [
"string"
],
"containerRegistry": "string",
"enabled": true,
"env": [],
"image": "string",
"models": [],
"name": "string",
"port": 80,
"region": "ny2",
"repositories": {
"dataset": "string",
"mountPath": "string",
"repositories": []
},
"resources": {
"instanceType": "string",
"replicas": 1
}
},
"deploymentId": "string",
"projectId": "string"
}curl -X POST \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
-d '{
"config": {
"apiVersion": "v0alpha0",
"command": [
"string"
],
"containerRegistry": "string",
"enabled": true,
"env": [],
"image": "string",
"models": [],
"name": "string",
"port": 80,
"region": "ny2",
"repositories": {
"dataset": "string",
"mountPath": "string",
"repositories": []
},
"resources": {
"instanceType": "string",
"replicas": 1
}
},
"deploymentId": "string",
"projectId": "string"
}' \
"https://api.paperspace.com/v1/deployments"Responses
200
Successful response
application/json
deploymentId
required
The ID of the deployment
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"deploymentId": "string"
}{
"code": "string",
"message": "string"
}GET Get a deployment
/deployments/{id}
Authorizations:
BearerAuth
An API key or access token
Fetches a single deployment by deployment ID.
Path Parameters
id
required
The ID of the deployment to fetch
Request: /deployments/{id}
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments/{id}"Responses
200
Successful response
application/json
basicAuthKey
optional Nullable
The endpoint security key for the deployment
dtCreated
required
The date the deployment was created
endpoint
required
The unique endpoint for the deployment
id
required
The ID of the deployment
latestSpec
optional Nullable
The latest deployment configuration. If invalid, null is returned.
Show child properties
data
optional Nullable
The data for the deployment spec
Option 2
apiVersion
required
basicAuthKey
optional
command
optional
containerRegistry
optional
enabled
optional
env
optional
Show child properties
name
required
value
required
healthChecks
optional
Show child properties
liveness
optional
readiness
optional
startup
optional
healthchecks
optional
Show child properties
liveness
optional
readiness
optional
startup
optional
image
required
integrations
optional
name
required
region
optional
resources
required
Show child properties
autoscaling
optional
machineType
required
ports
required
replicas
optional
deploymentId
required
The ID of the deployment the spec belongs to
dtHealthy
optional Nullable
The date the deployment was marked "healthy"
error
optional Nullable
The fatal configuration error. Only present if the cluster was unable to apply the entire deployment configuration. This is not the same as an instance error.
externalApplied
optional Nullable
The date the deployment configuration was applied to the cluster
id
required
The ID of the deployment spec
metadata
optional Nullable
Metadata about the source of the configuration
Show child properties
gitHeaders
optional
Show child properties
x-git-actor
required
x-git-host
required
x-git-owner
required
x-git-ref
required
x-git-repo
required
x-git-sha
required
userId
required
The ID of the user the deployment belongs to
latestSpecHash
optional Nullable
The last version hash for the deployment
name
required
The name of the deployment
projectId
required
The ID of the project the deployment belongs to
teamId
required
The ID of the team the deployment belongs to
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"basicAuthKey": "string",
"dtCreated": "2019-08-24T14:15:22Z",
"endpoint": "string",
"id": "string",
"latestSpec": {
"data": {
"apiVersion": "v0alpha0",
"command": [],
"containerRegistry": "string",
"enabled": true,
"env": [],
"image": "string",
"models": [],
"name": "string",
"port": 80,
"region": "ny2"
},
"deploymentId": "string",
"dtHealthy": "2019-08-24T14:15:22Z",
"error": "string",
"externalApplied": "2019-08-24T14:15:22Z",
"id": "string",
"userId": "string"
},
"latestSpecHash": "string",
"name": "string",
"projectId": "string",
"teamId": "string"
}{
"code": "string",
"message": "string"
}DELETE Delete a deployment
/deployments/{id}
Authorizations:
BearerAuth
An API key or access token
Deletes a deployment by deployment ID.
Path Parameters
id
required
The ID of the deployment to delete
Request: /deployments/{id}
curl -X DELETE \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments/{id}"Responses
200
Successful response
application/json
id
required
The ID of the deleted deployment
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"id": "string"
}{
"code": "string",
"message": "string"
}GET List deployment history
/deployments/{id}/history
Authorizations:
BearerAuth
An API key or access token
Lists history for a given deployment.
Path Parameters
id
required
The ID of the deployment
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descRequest: /deployments/{id}/history
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments/{id}/history"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
data
optional Nullable
The data for the deployment spec
Option 2
apiVersion
required
basicAuthKey
optional
command
optional
containerRegistry
optional
enabled
optional
env
optional
Show child properties
name
required
value
required
healthChecks
optional
Show child properties
liveness
optional
readiness
optional
startup
optional
healthchecks
optional
Show child properties
liveness
optional
readiness
optional
startup
optional
image
required
integrations
optional
name
required
region
optional
resources
required
Show child properties
autoscaling
optional
machineType
required
ports
required
replicas
optional
deploymentId
required
The ID of the deployment the spec belongs to
dtHealthy
optional Nullable
The date the deployment was marked "healthy"
error
optional Nullable
The fatal configuration error. Only present if the cluster was unable to apply the entire deployment configuration. This is not the same as an instance error.
externalApplied
optional Nullable
The date the deployment configuration was applied to the cluster
id
required
The ID of the deployment spec
metadata
optional Nullable
Metadata about the source of the configuration
Show child properties
gitHeaders
optional
Show child properties
x-git-actor
required
x-git-host
required
x-git-owner
required
x-git-ref
required
x-git-repo
required
x-git-sha
required
userId
required
The ID of the user the deployment belongs to
workflowRun
optional Nullable
Show child properties
dtCreated
optional Nullable
When the workflow run was created
dtFinished
optional Nullable
When the workflow run finished
dtStarted
optional Nullable
When the workflow run started
id
required
The ID of the workflow run
message
optional Nullable
The message of the workflow run
phase
required
The phase of the workflow run
workflow
required
Show child properties
dtCreated
optional Nullable
When the workflow was created
id
required
The ID of the workflow
name
required Nullable
The name of the workflow
workflowId
required
The ID of the workflow
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"deploymentId": "string",
"dtHealthy": "2019-08-24T14:15:22Z",
"error": "string",
"externalApplied": "2019-08-24T14:15:22Z",
"id": "string",
"userId": "string"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}GET List deployment logs
/deployments/{id}/logs
Authorizations:
BearerAuth
An API key or access token
Lists logs for a given deployment.
Path Parameters
id
required
The ID of the deployment
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descinstanceId
optional
Get the logs for a particular instance ID
Request: /deployments/{id}/logs
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments/{id}/logs"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
dtCreated
required
The date the log was created.
id
required
ID of the log item
instanceId
optional Nullable
The instance ID the log is associated with.
jobId
required
The associated job ID of the log item.
message
required
The message of the log item.
uuid
optional Nullable
UUID representing the log item
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"dtCreated": "2019-08-24T14:15:22Z",
"id": "string",
"instanceId": "string",
"jobId": "string",
"message": "string",
"uuid": "string"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}GET List deployment metrics
/deployments/{id}/metrics
Authorizations:
BearerAuth
An API key or access token
Lists metrics for a given deployment.
Path Parameters
id
required
The ID of the deployment to fetch
Query Parameters
metric
required
The metric to fetch.
timeframe
optional
The time frame for the metrics request.
Request: /deployments/{id}/metrics
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments/{id}/metrics"Responses
200
Successful response
application/json
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"timestamp": "2019-08-24T14:15:22Z",
"value": "string"
}{
"code": "string",
"message": "string"
}GET List deployment runs
/deployments/{id}/runs
Authorizations:
BearerAuth
An API key or access token
Lists the active deployment runs for a deployment.
Path Parameters
id
required
The ID of the deployment to fetch
Query Parameters
limit
optional
The latest n number of deployment runs to return
Default:10Request: /deployments/{id}/runs
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/deployments/{id}/runs"Responses
Successful response
default
Error response
application/json
code
required
details
optional
message
required
Response
[
{
"availableReplicas": 0,
"id": "string",
"instances": [],
"readyReplicas": 0,
"replicas": 0
}
]{
"code": "string",
"message": "string"
}GET List a project's deployments
/projects/{id}/deployments
Authorizations:
BearerAuth
An API key or access token
Fetches a list of deployments for a project.
Path Parameters
id
required
The ID of the project to fetch deployments for
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descname
optional
Filter to deployments with names matching this string.
Request: /projects/{id}/deployments
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/projects/{id}/deployments"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
basicAuthKey
optional Nullable
The endpoint security key for the deployment
dtCreated
required
The date the deployment was created
endpoint
required
The unique endpoint for the deployment
id
required
The ID of the deployment
latestSpec
optional Nullable
The latest deployment configuration. If invalid, null is returned.
Show child properties
data
optional Nullable
The data for the deployment spec
Option 2
apiVersion
required
basicAuthKey
optional
command
optional
containerRegistry
optional
enabled
optional
env
optional
healthChecks
optional
healthchecks
optional
image
required
integrations
optional
name
required
region
optional
resources
required
deploymentId
required
The ID of the deployment the spec belongs to
dtHealthy
optional Nullable
The date the deployment was marked "healthy"
error
optional Nullable
The fatal configuration error. Only present if the cluster was unable to apply the entire deployment configuration. This is not the same as an instance error.
externalApplied
optional Nullable
The date the deployment configuration was applied to the cluster
id
required
The ID of the deployment spec
metadata
optional Nullable
Metadata about the source of the configuration
Show child properties
gitHeaders
optional
userId
required
The ID of the user the deployment belongs to
latestSpecHash
optional Nullable
The last version hash for the deployment
name
required
The name of the deployment
projectId
required
The ID of the project the deployment belongs to
teamId
required
The ID of the team the deployment belongs to
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"basicAuthKey": "string",
"dtCreated": "2019-08-24T14:15:22Z",
"endpoint": "string",
"id": "string",
"latestSpecHash": "string",
"name": "string",
"projectId": "string",
"teamId": "string"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}